SystemOrganization addCategory: #'AdventureThing-Web-Admin'!
SystemOrganization addCategory: #'AdventureThing-Web-Common'!
SystemOrganization addCategory: #'AdventureThing-Web-Game'!

WATask subclass: #ATGame
	instanceVariableNames: 'world currentLocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Game'!

!ATGame class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:30'!
canBeRoot
	^true! !

!ATGame methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:22'!
go
	currentLocation := 
		(self call: (ATLocationView location: currentLocation))
			destination! !

!ATGame methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 18:10'!
initialize
	| repo |
	super initialize.
	repo := ATRepository default.
	world  := repo worldNamed: (repo worldNames asSortedCollection first).
	currentLocation := world locations first.! !

WAFileLibrary subclass: #ATAdminLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminLibrary methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 12:17'!
selectorsToInclude
	^#(styleCss)! !

!ATAdminLibrary methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 13:35'!
styleCss
^''! !

WAComponent subclass: #ATAdminEditLocation
	instanceVariableNames: 'location name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminEditLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 09:44'!
location: aLocation
	^self basicNew
		initializeWithLocation: aLocation;
		yourself.! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:14'!
close
	self answer! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 14:03'!
createExit
	(ATAddExitDialog location: location) show! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:23'!
deleteExit: anExit
	ATConfirmDialog new
		onConfirm: [ location removeExit: anExit ];
		show.! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:43'!
description
	^ description! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:43'!
description: anObject
	description := anObject! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 14:03'!
editExit: anExit
	(ATEditExitDialog for: anExit) show! !

!ATAdminEditLocation methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 09:50'!
initializeWithLocation: aLocation
	self initialize.
	location := aLocation.
	self reset.! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:43'!
name
	^ name! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:43'!
name: anObject
	name := anObject! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:15'!
renderContentOn: html
 | id |
	html form: [
		html fieldSet: [ html legend: 'Location Details'.
			html row: [ html div span: 4; with: [
				html label for: (id := html nextId) ; with: 'Name: '.
				html textInput class: 'input-xlarge'; id: id; on: #name of: self].
				
				html div class: 'well'; class: 'well-small'; span: 4; pullRight; with: [ self renderExitBoxOn: html ]].

			html label for: (id := html nextId); with: 'Description: '.
			html textArea class: 'input-block-level'; rows: 10; id: id; on: #description of: self].

			html div class: 'form-actions'; with: [ 
				html submitButton class: 'btn'; class: 'btn-primary'; callback: [ self save]; value: 'Save'.
				html submitButton class: 'btn'; callback: [ self close ]; value: 'close']]! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 12:16'!
renderExitBoxOn: html
	html legend with: 'Exits'.
	html div class: 'btn-group'; with: [
		html anchor class: 'btn'; class: 'btn-small'; callback: [ self createExit ]; with: [
			html icon: 'plus' ] ].
	location exits ifNotEmpty: [ self renderExitsOn: html ]! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 14:04'!
renderExitsOn: html
	html table class: '.table'; with: [
		html tableRow: [ html tableHeading: 'Direction'. html tableHeading: 'Destination'. html tableHeading: 'Action'].
		
		location exits do: [ :exit | 
			html tableRow: [ 
				html tableData: exit direction displayName.
				html tableData: exit destination name.
				html tableData: [ 
					html anchor callback: [ self deleteExit: exit ]; with: 'delete'.
					html space.
					html anchor callback: [ self editExit: exit ]; with: 'edit' ]]]]! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:48'!
reset
	description := location description.
	name := location name! !

!ATAdminEditLocation methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 09:48'!
save
	location
		name: name;
		description: description.
	self answer.! !

WAComponent subclass: #ATAdminEditLocations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:43'!
createLocation
	self session createLocation! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:28'!
deleteLocation: aLocation
	ATConfirmDialog new
		onConfirm: [ self world removeLocation: aLocation ];
		show! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 09:47'!
editLocation: aLocation
	self call: (ATAdminEditLocation location: aLocation)! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:30'!
locations
	^self world locations! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 14:13'!
overview
	self call: ATAdminOverview new! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:53'!
renderContentOn: html
	html form: [
		html fieldSet: [
			html legend: 'EditLocations' ].
		html div class: 'btn-group'; with: [
			html anchor class: 'btn'; callback: [ self createLocation ]; with: [
				html icon: 'plus'.
				html render: ' New Location' ].
			html anchor class: 'btn'; callback: [ self overview ]; with: [
				html icon: 'globe'.
				html render: 'Overview' ] ].
		self renderListOn: html.
			
	 ]! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 18:51'!
renderListOn: html
	html table class: 'table'; class: 'table-striped'; with: [
		html tableRow: [ 
			html tableHeading: 'Name'.
			html tableHeading: 'Actions' ].
		self locations do: [ :loc |
			html tableRow: [
				html tableData: loc name.
				html tableData: [ 
					html anchor callback: [ self editLocation: loc ]; with: 'Edit'.
					html space.
					html anchor callback: [ self deleteLocation: loc ]; with: 'Delete'  ]
				 ]
			 ]	
		
	 ]! !

!ATAdminEditLocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:30'!
world
	^self session world! !

WAComponent subclass: #ATAdminMenu
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminMenu methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:58'!
children
	^items! !

!ATAdminMenu methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:30'!
handleWorldChanged
	self updateEnabledState.! !

!ATAdminMenu methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:25'!
initialize
	super initialize.
	items := { 
		ATNavButton new label: 'Details'; callback: [ self session viewDetails].
		ATNavButton new label: 'Locations'; callback: [ self session viewLocations]}.
		
	self session on: ATAdminWorldChanged do: [ self handleWorldChanged ].
	self updateEnabledState.
! !

!ATAdminMenu methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:59'!
renderContentOn: html
	html unorderedList
		class: 'nav';
		with: [ 
			items do: [ :each | html render: each  ] ]! !

!ATAdminMenu methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:15'!
updateEnabledState
	| enabled |
	enabled := self session world notNil.
	self children do: [ :c | c enabled: enabled ].! !

WAComponent subclass: #ATAdminNavbar
	instanceVariableNames: 'worldMenu menuBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:58'!
children
	^Array with: menuBar! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:35'!
createWorld
	ATCreateWorldDialog show.! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:56'!
initialize
	super initialize.
	menuBar := ATAdminMenu new.
! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:58'!
renderContentOn: html
	html navBar with: [
		self renderWorldMenuOn: html.
		html space.
		html render: menuBar].
! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/28/2012 20:57'!
renderWorldMenuOn: html
	html div class: 'dropdown';
		with: [ html anchor
				class: 'brand';
				class: 'dropdown-toggle';
				attributeAt: 'data-toggle' put: 'dropdown';
				with: [ html render: self worldName.
					html span class: 'caret'].
			html unorderedList
				class: 'dropdown-menu';
				with: [ 
					self session world ifNotNil: [
						html listItem: [ html anchor callback: [self save] ; with: 'Save']  ].
					html listItem 
						with: [ html anchor callback: [ self selectWorld ]; with: 'Select World... ' ].
					html listItem
						with:[ html anchor callback: [self createWorld ]; with: 'Create World... ']]]! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/28/2012 20:57'!
save
	self session save.! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 21:05'!
selectWorld
	ATSelectWorldDialog show.! !

!ATAdminNavbar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:12'!
worldName
	^self session world 
		ifNil: [ '<none>' ]
		ifNotNil: [ :w | w name ]! !

WAComponent subclass: #ATAdminOverview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 14:52'!
idFor: aLocation
	^('ov{1}' format: { aLocation id greaseString}) asJavascript! !

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 14:27'!
locations
	^self session world locations! !

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 15:06'!
renderContentOn: html
	| stream |
	html legend: 'Overview'.
	html div id: 'overview'.

	stream  := WriteStream on: ''.
	stream nextPutAll: 'var g = new Graph();'.	
	self writeLocationsOn: stream.
	
	stream nextPutAll: '
var layouter = new Graph.Layout.Spring(g);
layouter.layout();
 
var renderer = new Graph.Renderer.Raphael(''overview'', g, $(''#overview'').width(), $(''#overview'').height());
renderer.draw(); '.
	html script: stream contents.
	html anchor class: 'btn'; callback: [ self answer ]; with: 'Close'.! !

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 14:57'!
updateRoot: aRoot
	super updateRoot: aRoot.
	aRoot script 
		url: ATAdminLibrary / #raphaelJs.
	aRoot script 
		url: ATAdminLibrary / #draculagraphJs.
	aRoot script 
		url: ATAdminLibrary / #draculagraffleJs.
	aRoot script 
		url: ATAdminLibrary / #draculaalgorithmsJs				! !

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 14:52'!
writeExitsFor: aLocation on: aStream
	aLocation exits do: [ :exit | 
		aStream nextPutAll: ( 'g.addEdge({1}, {2}, \{ directed: true });'
			format: {self idFor: exit origin. self idFor: exit destination}) ]! !

!ATAdminOverview methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 15:05'!
writeLocationsOn: stream
	self locations do: [ :loc |
		stream nextPutAll: ('g.addNode({1}, \{ label: {2}}); '
			format: { self idFor: loc. loc name asJavascript})].
	self locations do: [ :loc | self writeExitsFor: loc on: stream ]! !

WAComponent subclass: #ATAdminWorldDetails
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:25'!
description
	^ description! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:25'!
description: anObject
	description := anObject! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:23'!
initialize
	super initialize.
	self reset.! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:22'!
name
	^ name! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:22'!
name: anObject
	name := anObject! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:33'!
renderContentOn: html
 | id |
	html form: [
		html fieldSet: [
			html legend: 'World Details'.
			html label for: (id := html nextId) ; with: 'Name: '.
			html textInput class: 'input-xlarge'; id: id; on: #name of: self.
			
			html label for: (id := html nextId); with: 'Description: '.
			html textArea class: 'input-block-level'; rows: 10; id: id; on: #description of: self.
			html div class: 'form-actions'; with: [ 
				html submitButton class: 'btn'; class: 'btn-primary'; callback: [ self save]; value: 'Save'.
				html submitButton class: 'btn'; callback: [ self reset ]; value: 'Reset']]]! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:25'!
reset
	description := self session world description.
	name := self session world name! !

!ATAdminWorldDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 21:29'!
save
	self session world
		name: name;
		description: description.! !

WAComponent subclass: #ATDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

ATDialog subclass: #ATConfirmDialog
	instanceVariableNames: 'action title message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:27'!
cancel
	self answer: false! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:22'!
confirm
	action value.
	self answer: true! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:18'!
heading
	^title! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:19'!
initialize
	super initialize.
	action := [].
	title := 'Confirm'.
	message := 'Are you Sure?'.! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:26'!
onConfirm: aBlock
	action :=  aBlock! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:19'!
renderBodyOn: html
	html render: message! !

!ATConfirmDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:21'!
renderButtonsOn: html
	html submitButton
		class: 'btn'; class: 'btn-primary';
		callback: [ self confirm ];
		value: 'Ok'.
	html space.
	html cancelButton
		class: 'btn';
		callback: [ self cancel ];
		value: 'Cancel'! !

ATDialog subclass: #ATCreateLocationDialog
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 18:03'!
createLocation
	self session createLocationNamed: name.
	self close.! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:33'!
heading
	^'Create Location'! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:55'!
name
	^name! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:55'!
name: aString
	name := aString! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 17:12'!
renderBodyOn: html
	| id |
	
	html label for: (id := html nextId);	with: 'Name: '.
	html textInput on: #name of: self; id: id ! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 17:09'!
renderButtonsOn: html
	html submitButton
			class: 'btn'; class: 'btn-primary';
			callback: [ self createLocation ];
			value: 'Create Location'.
	html space.
	self renderCancelButtonOn: html  ! !

!ATCreateLocationDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:47'!
worldList
	^ATWorld worldNames! !

ATDialog subclass: #ATCreateWorldDialog
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:34'!
createWorld
	self session createWorldNamed: name.
	self close.! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:35'!
heading
	^'Create World'! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:34'!
name
	^name! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:34'!
name: aString
	name := aString! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:34'!
renderBodyOn: html
	| id |
	
	html label for: (id := html nextId);	with: 'Name: '.
	html textInput on: #name of: self; id: id ! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:35'!
renderButtonsOn: html
	html submitButton
			class: 'btn'; class: 'btn-primary';
			callback: [ self createWorld ];
			value: 'Create World'.
	html space.
	self renderCancelButtonOn: html  ! !

!ATCreateWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:34'!
worldList
	^ATWorld worldNames! !

!ATDialog class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:21'!
show
	self new show		! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:21'!
close
	self answer.! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:24'!
heading
	^''! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:30'!
renderBodyOn: html
! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:30'!
renderButtonsOn: html
	self renderCancelButtonOn: html! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 17:09'!
renderCancelButtonOn: html
	^ html cancelButton
		class: 'btn';
		value: 'Close';
		callback: [ self close ]! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:40'!
renderContentOn: html
	html form class: 'modal-form'; with: [
	html div class: 'modal-header';
		with: [ self renderHeadingOn: html ].
	html div class: 'modal-body'; 
		with: [ self renderBodyOn: html ].
	html div class: 'modal-footer';
		with: [ self renderButtonsOn: html ]]	! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:28'!
renderHeadingOn: html
	html heading level: 3; with: self heading! !

!ATDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:22'!
show
	self session showModal: self! !

ATDialog subclass: #ATEditExitDialog
	instanceVariableNames: 'exit direction destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

ATEditExitDialog subclass: #ATAddExitDialog
	instanceVariableNames: 'reciprocal location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAddExitDialog class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:02'!
location: aLocation
	^self basicNew
		initializeWithLocation: aLocation;
		yourself.! !

!ATAddExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:57'!
addExit
	| exit |
	exit := (ATExit from: location to: destination direction: direction).
	reciprocal 
		ifTrue: [ location addExitWithReciprocal: exit ]
		ifFalse: [ location addExit: exit ].
	self close.! !

!ATAddExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:02'!
initializeWithLocation: aLocation
	self initialize.
	location := aLocation.
	exit := ATExit from: aLocation to: nil direction: #north.
	reciprocal := true.
	self reset.
! !

!ATAddExitDialog methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:59'!
reciprocal
	^ reciprocal! !

!ATAddExitDialog methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:59'!
reciprocal: anObject
	reciprocal := anObject! !

!ATAddExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:59'!
renderBodyOn: html
	super renderBodyOn: html.
			
	html label class: 'checkbox'; with: [
		html checkbox on: #reciprocal of: self.
		html render: 'Add reciprocal exit? ' ]! !

!ATAddExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:00'!
saveAndClose
	self save.
	reciprocal 
		ifTrue: [ location addExitWithReciprocal: exit ]
		ifFalse: [ location addExit: exit ].
	self close.! !

!ATEditExitDialog class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:03'!
for: anExit
	^self basicNew
		initializeWithExit: anExit;
		yourself! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:05'!
destination
	^destination! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:05'!
destination: aLocation
	destination := aLocation! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:04'!
destinations
	^self session world 
		locations
		! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:59'!
direction
	^direction! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:59'!
direction: aDirection
	direction := aDirection! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:59'!
heading
	^'Edit Exit'! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:01'!
initializeWithExit: anExit.
	self initialize.
	exit := anExit.
	self reset.! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:59'!
renderBodyOn: html
	| id |
	html label for: (id := html nextId ); with: 'Direction'.
	html select
		id: id;
		on: #direction of: self;
		list: ATDirection directions;
		labels: [ :d | d displayName ].
		
	html label for: (id := html nextId ); with: 'Direction'.
	html select
		id: id;
		on: #destination of: self;
		list: self destinations;
		labels: [ :d | d name ].! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 13:58'!
renderButtonsOn: html
	html submitButton
			class: 'btn'; class: 'btn-primary';
			callback: [ self saveAndClose ];
			value: 'Ok'.
	html space.
	self renderCancelButtonOn: html  ! !

!ATEditExitDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:01'!
reset
	direction :=  exit direction.
	destination := exit destination.! !

!ATEditExitDialog methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 13:58'!
save
	exit
		direction: direction;
		destination: destination! !

!ATEditExitDialog methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2012 14:00'!
saveAndClose
	self save.
	self close.! !

ATDialog subclass: #ATSelectWorldDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATSelectWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 12:38'!
heading
	^'Select World'! !

!ATSelectWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 18:17'!
renderBodyOn: html
	html unorderedList: [
		self worldList do: [ :w |
			html listItem: [ html anchor callback: [ self selectWorld: w ]; with: w ]]]! !

!ATSelectWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 21:02'!
selectWorld: aString
	self session selectWorldNamed: aString.
	self close.! !

!ATSelectWorldDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 18:16'!
worldList
	^ATRepository default
		worldNames asSortedCollection! !

WAComponent subclass: #ATLocationView
	instanceVariableNames: 'location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Game'!

!ATLocationView class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:22'!
location: aLocation
	^self basicNew
		initializeWithLocation: aLocation;
		yourself! !

!ATLocationView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:23'!
initializeWithLocation: aLocation
	self initialize.
	location := aLocation.! !

!ATLocationView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:38'!
renderContentOn: html
	html container: [
		html heading level: 1; with: location name.
		
		((location description ifNil: ['' ] )splitOn: Character cr) do: [ :text |
			html paragraph: text ].
	html div class: 'well'; with: [html legend: 'Which way will you go?'.
		html unorderedList
			list: location exits;
			labels: [ :exit | exit direction displayName ];
			callback: [ :exit | self answer: exit ]]].
	! !

!ATLocationView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2012 14:36'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5! !

WAComponent subclass: #ATNavButton
	instanceVariableNames: 'active callback enabled label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATNavButton class methodsFor: 'instance creation' stamp: 'StuartHerring 11/21/2012 20:26'!
callback: callback label: label

	^ self new
		callback: callback;
		label: label;
		yourself! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
active
	^ active! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
active: anObject
	active := anObject! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
callback
	^ callback! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
callback: anObject
	callback := anObject! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:26'!
enabled
	^enabled! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:25'!
enabled: aBoolean
	enabled := aBoolean! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:25'!
initialize
	super initialize.
	active := false.
	enabled := true.! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
label
	^ label! !

!ATNavButton methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2012 20:23'!
label: anObject
	label := anObject! !

!ATNavButton methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:29'!
renderContentOn: html
	html listItem
		class: 'active' if: active;
		with: [ ((enabled and: [ active not]) 
				 ifTrue: [html anchor callback: callback ]
				ifFalse: [html anchor class: 'disabled' if: enabled not ])
					with: label]! !

WAComponent subclass: #ATWorldEditor
	instanceVariableNames: 'navBar body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATWorldEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
canBeRoot
	^true! !

!ATWorldEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
children
	^Array with: navBar with: body! !

!ATWorldEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:54'!
initialize
	super initialize.
	navBar := ATAdminNavbar new.
	body := nil.
	self session on: ATAdminShowComponent
		do: [ :ann | self updateBody: ann component ].! !

!ATWorldEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
renderContentOn: html
	html render: navBar.
	html container: [ 
		html row: [ html render: body ]]! !

!ATWorldEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:12'!
updateBody: aComponent
	body := aComponent! !

!ATWorldEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5.! !

WASession subclass: #ATWorldEditorSession
	instanceVariableNames: 'world announcer modalComponent repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
announce: anAnnouncement
	announcer announce: anAnnouncement! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
announcer
	^announcer! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/28/2012 21:17'!
commit: aBlock
	aBlock value.
	repository save: world.! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 18:00'!
createLocation
	ATCreateLocationDialog show.! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 18:08'!
createLocationNamed: aByteString 
	world addLocation: (ATLocation  name: aByteString).! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/28/2012 20:58'!
createWorldNamed: aName
	(ATRepository default worldNamed: aName) ifNotNil: [
		self error: 'A world with that name already exists' ].
	world := repository save: (ATWorld new name: aName) .
	self announce: ATAdminWorldChanged new.! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/30/2012 17:00'!
initialize
	super initialize.
	modalComponent := nil.
	announcer := Announcer new.
	announcer on: ATAdminWorldChanged do: [ self viewLocations ].
	repository := ATRepository default! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:43'!
modalComponent
	^modalComponent! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
on: anAnnouncement do: aBlock
	announcer on: anAnnouncement do: aBlock! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/30/2012 17:08'!
save
	repository save: world! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/28/2012 20:58'!
selectWorldNamed: aString
	world := repository worldNamed: aString.
	self announce: ATAdminWorldChanged new.! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:45'!
showModal: aComponent
	modalComponent := aComponent.
	aComponent onAnswer: [ modalComponent := nil ]! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 17:04'!
transactionProvider
	^nil! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 21:30'!
viewDetails
	self announce: (ATAdminShowComponent component: ATAdminWorldDetails new)! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/23/2012 17:21'!
viewLocations
	self announce: (ATAdminShowComponent component: ATAdminEditLocations new)! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
world
	^world! !

!ATWorldEditorSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:11'!
world: aWorld
	world := aWorld! !

Announcement subclass: #ATAdminShowComponent
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATAdminShowComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2012 21:23'!
component: aComponentOrView
	^self basicNew
		initializeWithComponentOrView: aComponentOrView;
		yourself! !

!ATAdminShowComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2012 21:48'!
new
	self shouldNotImplement! !

!ATAdminShowComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2012 21:17'!
component
	^component! !

!ATAdminShowComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2012 21:47'!
initializeWithComponentOrView: aComponent
	self initialize.
	component := aComponent! !

Announcement subclass: #ATAdminWorldChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

Object subclass: #ATDeploymentTools
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Common'!

!ATDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'Jenkins 12/1/2012 15:53'!
register: aRootComponent asDefaultAt: aString
	| application |
	application := self register: aRootComponent at: aString.	
	WADispatcher default defaultName: aString.
	^application! !

!ATDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'Jenkins 12/1/2012 15:53'!
register: aRootComponent at: aString
	| application |
	application := WAAdmin register: aRootComponent asApplicationAt: aString.

	^application! !

!ATDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 12/1/2012 17:35'!
registerAdminAt: aString
	| application |
	application := self register: ATWorldEditor at: aString.
	
	application
		preferenceAt: #sessionClass put: ATWorldEditorSession;
		preferenceAt: #rootDecorationClasses put: { ATModalDecoration };
		preferenceAt: #libraries put: { JQDeploymentLibrary. BSBootstrapLibrary. ATAdminLibrary}.
				
	^application! !

!ATDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'Jenkins 12/1/2012 15:53'!
registerDefault
	self registerGameAt: 'worldView'.
	self registerAdminAt: 'worldEdit'! !

!ATDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'Jenkins 12/1/2012 15:53'!
registerGameAt: aString
	| application |
	application := self register: ATGame asDefaultAt: aString.
	
	application
		preferenceAt: #libraries put: { JQDeploymentLibrary. BSBootstrapLibrary}.
				
	^application! !

WADecoration subclass: #ATModalDecoration
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdventureThing-Web-Admin'!

!ATModalDecoration class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 21:04'!
canBeRoot
	^true! !

!ATModalDecoration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/21/2012 20:52'!
children
	^Array with: self session modalComponent! !

!ATModalDecoration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2012 17:31'!
renderContentOn: html
	self renderNextOn: html.
	self session modalComponent
		ifNotNil: [ :c | 
			html div
				class: 'modal';
				id: 'modal';
				with: c .
	html
		script: '$("#modal").on("shown", function(event) { $(this).find("input:first").focus() });';
		script:
			((html jQuery id: 'modal')
				call: 'modal'
				with:
					{('backdrop' -> 'static').
					('keyboard' -> false)} asDictionary)].! !
